/***************************************************************************
                          kap_classselectorpage.cpp  -  description
                             -------------------
    begin                : Sun Feb 27 2000
    copyright            : (C) 2000 by jec
    email                : cuendet@linkvest.ch
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


#include <qlistbox.h>
#include <qlayout.h>
#include <qpushbutton.h>
#include <qtoolbutton.h>
#include <kiconloader.h>
#include <klocale.h>
#include <qlabel.h>

#include "kprintermanager.h"
#include "kprinter.h"
#include <qstrlist.h>

#include "kap_classselectorpage.h"

#include "kprinterdescription.h"



Kap_ClassSelectorPage::Kap_ClassSelectorPage(QWidget *parent, const char *name )
:Kap_WizardPage(parent,name)
{
	setTitle(i18n("Choose the printers to add to the new CLASS"));

	allPrintersBox_ = new QListBox(this);
	allPrintersBox_->setSelectionMode(QListBox::Extended);
	selPrintersBox_ = new QListBox(this);
	selPrintersBox_->setSelectionMode(QListBox::Extended);

	oneMoreButton_ = new QToolButton(this);
	oneMoreButton_->setIconSet(BarIcon("forward"));
	oneLessButton_ = new QToolButton(this);
	oneLessButton_->setIconSet(BarIcon("back"));

        QLabel	*l1 = new QLabel(i18n("Available printers:"), this);
        QLabel	*l2 = new QLabel(i18n("Selected printers:"), this);

        QHBoxLayout	*mainLayout_ = new QHBoxLayout(this, 10, 15);
        QVBoxLayout	*btnLayout_ = new QVBoxLayout(0, 0, 20);
        QVBoxLayout	*left_ = new QVBoxLayout(0, 0, 5), *right_ = new QVBoxLayout(0, 0, 5);
        mainLayout_->addLayout(left_, 1);
        mainLayout_->addLayout(btnLayout_, 0);
	mainLayout_->addLayout(right_, 1);
        left_->addWidget(l1, 0);
        left_->addWidget(allPrintersBox_, 1);
        btnLayout_->addStretch(1);
        btnLayout_->addWidget(oneMoreButton_, 0);
        btnLayout_->addWidget(oneLessButton_, 0);
        btnLayout_->addStretch(1);
        right_->addWidget(l2, 0);
        right_->addWidget(selPrintersBox_, 1);

	initWidgets();
}
Kap_ClassSelectorPage::~Kap_ClassSelectorPage()
{
}

void Kap_ClassSelectorPage::initWidgets()
{
	connect( oneMoreButton_, SIGNAL(clicked()), this, SLOT(slotOneMore()) );
	connect( oneLessButton_, SIGNAL(clicked()), this, SLOT(slotOneLess()) );

	QStrList list;
	KPrinterManager* mgr = KPrinterManager::get();
	QStrList *prlist = KPrinterDescription::get()->getPrintersList();
	if (mgr == 0)
	{
		return;
	}
	for (int i=0;i<mgr->getNbPrinters();i++)
	{
		KPrinter* p = mgr->getPrinterAt(i);
		if (!prlist || prlist->find(p->getName().data()) == -1) list.append( p->getName().data() );
	}
	allPrintersBox_->insertStrList(&list);
	if (prlist) selPrintersBox_->insertStrList(prlist);
	allPrintersBox_->sort();
	selPrintersBox_->sort();
}

void Kap_ClassSelectorPage::slotOneMore()
{
	for (int i=0;i<(int)allPrintersBox_->count();i++)
		if (allPrintersBox_->isSelected(i))
		{
			selPrintersBox_->insertItem(allPrintersBox_->text(i));
			allPrintersBox_->removeItem(i--);
		}
	selPrintersBox_->sort();
}
void Kap_ClassSelectorPage::slotOneLess()
{
	for (int i=0;i<(int)selPrintersBox_->count();i++)
		if (selPrintersBox_->isSelected(i))
		{
			allPrintersBox_->insertItem(selPrintersBox_->text(i));
			selPrintersBox_->removeItem(i--);
		}
	allPrintersBox_->sort();
}

bool Kap_ClassSelectorPage::canNextPage(QString& msg)
{
	if (selPrintersBox_->count() > 0)
	{
		return true;
	}
	msg = "You must select at least one printer to add to class!";
	return false;
}

Kap_Main::e_PageType Kap_ClassSelectorPage::getNextPage(QString&, bool fake)
{
	if (fake) return Kap_Main::NameSelector;

	KPrinterDescription* descr = KPrinterDescription::get();
	QStrList* list = new QStrList;
	for (int i=0;i<(int)selPrintersBox_->count();i++)
	{
		list->append(selPrintersBox_->text(i));
	}
	descr->setPrintersList(list);
	return Kap_Main::NameSelector;
}
Kap_Main::e_PageType Kap_ClassSelectorPage::getType() const
{
	return Kap_Main::ClassSelector;
}
