#ifndef	KAP_IPPUTIL_H
#define	KAP_IPPUTIL_H

#define	_FILE		0x001
#define	_PARALLEL	0x002
#define	_SERIAL		0x004
#define	_SMB		0x008
#define	_SOCKET		0x010
#define	_LPD		0x020
#define	_IPP		0x040
#define	_USB		0x080
#define	_HTTP		0x100

#define	HAS_FILE(x)	((x)&_FILE)
#define	HAS_PARALLEL(x)	((x)&_PARALLEL)
#define	HAS_SERIAL(x)	((x)&_SERIAL)
#define	HAS_SMB(x)	((x)&_SMB)
#define	HAS_SOCKET(x)	((x)&_SOCKET)
#define	HAS_LPD(x)	((x)&_LPD)
#define	HAS_IPP(x)	((x)&_IPP)
#define	HAS_USB(x)	((x)&_USB)
#define	HAS_HTTP(x)	((x)&_HTTP)

#include <qstring.h>
#include <qstrlist.h>
#include <qlist.h>

struct DeviceInfo
{
	QString	Class;
	QString	Info;
	QString	MakeAndModel;
	QString	URI;
	int	Type;
};

#define	PARALLEL_TYPE	0
#define	SERIAL_TYPE	1
#define	USB_TYPE	2

class Kap_IppUtil
{
public:
	static int getAvailableBackends();
	static QList<DeviceInfo>* getLocalPrinters();
	static QList<DeviceInfo>* getParallelPrinters();
	static QList<DeviceInfo>* getSerialPrinters();
	static QList<DeviceInfo>* getUSBPrinters();
	static bool hasCupsServer(const QString& host, int port = 631);
	static QStrList* getPrinterList(const QString& host, int port = 631, const QString& user = "", const QString& passwd = "");

private:
	static void saveConfig();
	static void restoreConfig();
	static QList<DeviceInfo>* getDevicePrinters(const char* backend);
	static QList<DeviceInfo>* getDevicePrinters(QStrList *backends);

	static QString	server_;
	static QString	user_;
	static QString	passwd_;
	static int	port_;
};

#endif
