/***************************************************************************
                          kap_namelocationselectorpage.cpp  -  description
                             -------------------
    begin                : Tue Feb 8 2000
    copyright            : (C) 2000 by jec
    email                : cuendet@linkvest.ch
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


#include <qlabel.h>
#include <qlineedit.h>
#include <qlayout.h>


#include "kups.h"
#include "kap_namelocationselectorpage.h"
#include "kap_backendselector.h"
#include "kprinterdescription.h"



Kap_NameLocationSelectorPage::Kap_NameLocationSelectorPage(QWidget *parent, const char *name )
:Kap_WizardPage(parent,name)
{
	setTitle(i18n("General informations"));

	explLabel_ = new QLabel(this);
	explLabel_->setText(i18n("<p>Enter informations about your printer or class. <b>Name</b> is mandatory, <b>Description</b> and <b>Location</b> are not.</p>"));

	nameLabel_ = new QLabel(this);
	nameLabel_->setText(i18n("Printer name:"));
	nameLineEdit_ = new QLineEdit(this);
	nameLineEdit_->setFixedHeight( nameLineEdit_->sizeHint().height() );
	nameLabel_->setFixedHeight( nameLineEdit_->height() );

	locationLabel_ = new QLabel(this);
	locationLabel_->setText(i18n("Physical location:"));
	locationLineEdit_ = new QLineEdit(this);
	locationLineEdit_->setFixedHeight( nameLineEdit_->sizeHint().height() );
	locationLabel_->setFixedHeight( locationLineEdit_->height() );

	descriptionLabel_ = new QLabel(i18n("Printer description:"),this);
	descriptionLineEdit_ = new QLineEdit(this);
	descriptionLineEdit_->setFixedHeight( nameLineEdit_->sizeHint().height() );
	descriptionLabel_->setFixedHeight( descriptionLineEdit_->height() );

	QVBoxLayout	*left_ = new QVBoxLayout(0, 0, 10), *right_ = new QVBoxLayout(0, 0, 10);
	QHBoxLayout *sub_ = new QHBoxLayout(0, 0, 10);
	QVBoxLayout	*main_ = new QVBoxLayout(this, 10, 30);
	main_->addWidget(explLabel_, 0);
	main_->addLayout(sub_, 1);
	sub_->addLayout(left_, 1);
	sub_->addLayout(right_, 2);
	left_->addWidget(nameLabel_);
	left_->addWidget(locationLabel_);
	left_->addWidget(descriptionLabel_);
	left_->addStretch(1);
	right_->addWidget(nameLineEdit_);
	right_->addWidget(locationLineEdit_);
	right_->addWidget(descriptionLineEdit_);
	right_->addStretch(1);

	connectWidgets();
}
Kap_NameLocationSelectorPage::~Kap_NameLocationSelectorPage()
{
}

void Kap_NameLocationSelectorPage::connectWidgets()
{
	connect( nameLineEdit_, SIGNAL(returnPressed()), this, SLOT(slotValidate()) );
	connect( locationLineEdit_, SIGNAL(returnPressed()), this, SLOT(slotValidate()) );
}

bool Kap_NameLocationSelectorPage::initialize()
{
        KPrinterDescription	*descr = KPrinterDescription::get();
	if (!descr->getName().isEmpty()) nameLineEdit_->setText(descr->getName());
	if (!descr->getDescription().isEmpty()) descriptionLineEdit_->setText(descr->getDescription());
	if (!descr->getLocation().isEmpty()) locationLineEdit_->setText(descr->getLocation());
	nameLineEdit_->selectAll();
        nameLineEdit_->setFocus();
	if (descr->getType() == KPrinterManager::e_Class)
	{
		nameLabel_->setText(i18n("Class name:"));
		descriptionLabel_->setText(i18n("Class description:"));
	}
	else
	{
		nameLabel_->setText(i18n("Printer name:"));
		descriptionLabel_->setText(i18n("Printer description:"));
	}
	return true;
}

void Kap_NameLocationSelectorPage::slotValidate()
{	
}
	
Kap_Main::e_PageType Kap_NameLocationSelectorPage::getNextPage(QString& message, bool fake)
{
	if (fake) return Kap_Main::Confirmation;

	KPrinterDescription* parDet = KPrinterDescription::get();
	parDet->setName( nameLineEdit_->text() );
	parDet->setLocation( locationLineEdit_->text() );
	parDet->setDescription( descriptionLineEdit_->text() );
	
	message = "";
	return Kap_Main::Confirmation;
}
Kap_Main::e_PageType Kap_NameLocationSelectorPage::getType() const
{
	return Kap_Main::NameSelector;
}

bool Kap_NameLocationSelectorPage::canNextPage(QString& msg)
{
	if ( QString(nameLineEdit_->text()).isEmpty() )
	{
		msg = i18n("You must provide a printer name!");
		return false;
	}
	return true;
}
