#ifndef KAP_PRINTERGROUP_H
#define KAP_PRINTERGROUP_H

#include <cups/ppd.h>
#include <qlist.h>
#include <qwidget.h>

class Kap_PrinterOption;

class Kap_PrinterGroup : public QWidget
{
public:
	Kap_PrinterGroup(ppd_group_t *group = 0, QWidget *parent = 0);
	~Kap_PrinterGroup();

	void init(ppd_group_t *group);
	bool hasSubGroups() { return (subgroups_.count() > 0); }
	QSize sizeHint();
	const char* groupname() { return group_->text; }

protected:
	void resizeEvent(QResizeEvent *);

private:
	ppd_group_t	*group_;
	QList<Kap_PrinterOption>	options_;
	QList<Kap_PrinterGroup>		subgroups_;
	QSize		size_;
};

#endif
