/***************************************************************************
                          kclasshelper.cpp  -  description
                             -------------------
    begin                : Wed Dec 20 2000
    copyright            : (C) 2000 by Michael Goffioul
    email                : goffioul@imec.be
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


#include <cups/cups.h>

#include "kclasshelper.h"

#include "kups_ipprequest.h"
#include "kups_infos.h"
#include "kprintermanager.h"
#include "kprinter.h"




KClassHelper* KClassHelper::unique_ = 0;

KClassHelper::KClassHelper()
{
}
KClassHelper::~KClassHelper()
{
}

KClassHelper* KClassHelper::get()
{
	if (unique_ == 0)
	{
		unique_ = new KClassHelper;
	}
	return unique_;
}

//----------------------------------------------------------------------
bool KClassHelper::remove(KPrinter* c)
{
	bool ret = false;
	KClassPrinter* classe = (KClassPrinter*)c;
	Kups_IppRequest request;
	
	request.setUri("printer-uri", c->getIppURI());
	request.setOperation(CUPS_DELETE_PRINTER);
	if (request.doRequest("/admin/"))
	{		
		ret = true;
    if (request.getResponseStatus() == IPP_NOT_FOUND)
    {
    	QString error;
	    error.sprintf("Destination %s does not exist!\n", c->getName().data());
      KPrinterManager::setLastError(error);
	    ret = false;
    }
	}
	else
	{
		ret = false;
	}

	return ret;
}

//---------------------------------------------------------------------
bool KClassHelper::removeFromClass(KPrinter* printer, KPrinter* other)
{
	if (!other->isA("KClassPrinter"))
	{
		return false;
	}
	KClassPrinter* classe = (KClassPrinter*)other;
	bool ret = false;
	
	// Prepare request
	Kups_IppRequest request;
	request.setOperation(CUPS_DELETE_CLASS);
	request.setUri("printer-uri", classe->getIppURI());
	
	if (request.doRequest("/admin/"))
	{
		ret = (request.getResponseStatus() == IPP_OK);
	}
	return ret;
}

//----------------------------------------------------------------------
bool KClassHelper::setAttribute(KPrinter* printer, ipp_attribute_t* attr)
{
	if (Kups_Helper::setAttribute(printer, attr))
	{
		return true;
	}
	
	if (attr->group_tag != IPP_TAG_PRINTER)
 	{
 		return false;
 	}
 	
 	KClassPrinter* classe = (KClassPrinter*)printer;
 	
	if ( strcmp(attr->name, "member-uris" ) == 0 )
	{
		for (int i=0;i<attr->num_values;i++)
		{	
			classe->addPrinterToClass(QString(attr->values[i].string.text));
		}
	}
	else
	{
		return false;
	}
	
	return true;
}
