/***************************************************************************
                          kprinterhelper.cpp  -  description
                             -------------------
    begin                : Wed Dec 20 2000
    copyright            : (C) 2000 by Michael Goffioul
    email                : goffioul@imec.be
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


#include "kprinterhelper.h"

#include "kups_ipprequest.h"
#include "kups_infos.h"
#include "kprinter.h"
#include "kprintermanager.h"




KPrinterHelper* KPrinterHelper::unique_ = 0;

KPrinterHelper::KPrinterHelper()
{
}
KPrinterHelper::~KPrinterHelper()
{
}

//----------------------------------------------------------------------
KPrinterHelper* KPrinterHelper::get()
{
	if (unique_ == 0)
	{
		unique_ = new KPrinterHelper;
	}
	return unique_;
}

//----------------------------------------------------------------------
bool KPrinterHelper::remove(KPrinter* p)
{
	bool ret = false;
	KRealPrinter* printer = (KRealPrinter*)p;
	Kups_IppRequest request;
	
	request.setUri("printer-uri", p->getIppURI());
	request.setOperation(CUPS_DELETE_PRINTER);
	if (request.doRequest("/admin/"))
	{		
		ret = true;
    if (request.getResponseStatus() == IPP_NOT_FOUND)
    {
    	QString error;
	    error.sprintf("Destination %s does not exist!\n", p->getName().data());
      KPrinterManager::setLastError(error);
	    ret = false;
    }
	}
	else
	{
		ret = false;
	}

	return ret;
}

//----------------------------------------------------------------------
bool KPrinterHelper::setAttribute(KPrinter* printer, ipp_attribute_t* attr)
{
	if (Kups_Helper::setAttribute(printer, attr))
	{
		return true;
	}
	
	return false;
}
