/***************************************************************************
                          kups.cpp  -  description
                             -------------------
    begin                : Mon Nov  8 19:59:21 CET 1999
    copyright            : (C) 1999 by jec
    email                : cuendet@linkvest.ch
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

// include files for QT
#include <qdir.h>
#include <qstrlist.h>
#include <qtcups/qcupsprintdialog.h>
#include <qpainter.h>
#include <qfile.h>
#include <qfileinfo.h>

// include files for KDE
#include <kiconloader.h>
#include <qmessagebox.h>
#include <kfiledialog.h>
//#include <kmenubar.h>
#include <kstddirs.h>
#include <kaction.h>
#include <kstdaction.h>
#include <kedittoolbar.h>
#include <kstdaccel.h>

#include <cupsddialog.h>

// application specific includes
#include "kups.h"
#include "kupsview.h"
#include "resource.h"

#include "kups_ipprequest.h"
#include "kups_optionsdialog.h"
#include "kups_configdialog.h"

#include "kaddprinterwizard.h"

#include "kprintermanager.h"
#include "kprinter.h"

//#include "kap_manumodeldico.h"

extern int cups_get_dests(const char *f, int n, cups_dest_t **d);

//----------------------------------------------------------
KupsApp* KupsApp::unique_ = 0;
//----------------------------------------------------------
KupsApp* KupsApp::get()
{
	return unique_;
}


//----------------------------------------------------------
KupsApp::KupsApp()
:isValid_(true)
{
	if(unique_ != 0)
	{
		QMessageBox::warning(this,"Kups","KupsApp is NOT UNIQUE",QMessageBox::Ok|QMessageBox::Default,0);
	}
	unique_ = this;

	//Kap_ManuModelDico::get();

//  config_ = kapp->sessionConfig();
  config_ = KGlobal::config();

  ///////////////////////////////////////////////////////////////////
  // call inits to invoke all other construction parts
  if (!initView())
  {
  	isValid_ = false;
  }
  initStatusBar();
  initActions();
/*  initToolBar();
  initMenuBar();
  initKeyAccel();
*/

  readOptions();
  checkCUPSAccess();
}

KupsApp::~KupsApp()
{
}

/*void KupsApp::initKeyAccel()
{
  keyAccel_ = new KAccel(this);

  keyAccel_->connectItem(KStdAccel::Quit, this, SLOT(slotFileQuit()));

  //keyAccel_->connectItem(KStdAccel::Help, kapp, SLOT(appHelpActivated()));

  keyAccel_->changeMenuAccel(fileMenu_, ID_FILE_QUIT, KStdAccel::Quit);

  keyAccel_->readSettings();
}

void KupsApp::initMenuBar()
{
  ///////////////////////////////////////////////////////////////////
  // menuBar entry fileMenu
  fileMenu_ = new QPopupMenu();
  fileMenu_->insertItem(SmallIcon("configure"), i18n("&Options"), ID_FILE_OPTIONS);
  fileMenu_->insertItem(SmallIcon("configure"), i18n("&Configure CUPS daemon"), ID_FILE_SERVER);
  fileMenu_->insertSeparator();
  fileMenu_->insertItem(SmallIcon("exit"), i18n("E&xit"), ID_FILE_QUIT);

  printingMenu_ = new QPopupMenu();
	printingMenu_->insertItem(SmallIcon("fileprint"), i18n("&Test page"), ID_PRINTING_TEST);
  printingMenu_->insertItem(SmallIcon("fileprint"), i18n("&PS file"), ID_PRINTING_PS_FILE);

  printerMenu_ = new QPopupMenu();
  printerMenu_->insertItem(SmallIcon("kups_add"), i18n("&Add"), ID_PRINTER_ADD);

  ///////////////////////////////////////////////////////////////////
  // menuBar entry viewMenu
  viewMenu_ = new QPopupMenu();
  viewMenu_->setCheckable(true);
  viewMenu_->insertItem(i18n("&Toolbar"), ID_VIEW_TOOLBAR);
  viewMenu_->insertItem(i18n("&Statusbar"), ID_VIEW_STATUSBAR);

  ///////////////////////////////////////////////////////////////////
  // menuBar entry helpMenu
  QString aboutstring;
  //aboutstring = kapp->appName()+" "+VERSION+"\n\n";
  aboutstring = QString("KUPS") + " " + VERSION+"\n\n";
	aboutstring += "(c) by jec and mgo\n";
  aboutstring += "Made by \n";
	aboutstring += "   Jean-Eric Cuendet   <cuendet@linkvest.ch>\n";
  aboutstring += "   Michael Goffioul    <goffioul@emic.ucl.ac.be>\n";
  aboutstring += "   CUPS mailing-list : <cups-devel@cups.sourceforge.net>\n";
  aboutstring += "\n";
  aboutstring += "Information about KUPS and free printer drivers\n";
  aboutstring += "to be used with CUPS can be found at cups.sourceforge.net\n";
  aboutstring += "More information about CUPS can be found at www.cups.org\n";
  aboutstring += "\n";
  aboutstring += "This program is free software and is provided\n";
  aboutstring += "as is under The GNU Public License v2 or later\n";
  aboutstring += "\n";
  aboutstring += "A copy of the GPL can be found at www.gnu.org\n";

  //helpMenu_ = helpMenu("Kups2 0.1\n\n(c) 2000 by\njec\ncups-devel@sourceforge.net");
  helpMenu_ = helpMenu(aboutstring);

  ///////////////////////////////////////////////////////////////////
  // MENUBAR CONFIGURATION
  // insert your popup menus with the according menubar entries in the order
  // they will appear later from left to right
  menuBar()->insertItem(i18n("&File"), fileMenu_);
  menuBar()->insertItem(i18n("&Print"), printingMenu_);
  menuBar()->insertItem(i18n("&Printer"), printerMenu_);
  menuBar()->insertItem(i18n("&View"), viewMenu_);

  menuBar()->insertSeparator();
  menuBar()->insertItem(i18n("&Help"), helpMenu_);

  ///////////////////////////////////////////////////////////////////
  // CONNECT THE MENU SLOTS WITH SIGNALS
  // for execution slots and statusbar messages

  connect(fileMenu_, SIGNAL(activated(int)), SLOT(commandCallback(int)));
  connect(fileMenu_, SIGNAL(highlighted(int)), SLOT(statusCallback(int)));

  connect(printingMenu_, SIGNAL(activated(int)), SLOT(commandCallback(int)));
  connect(printingMenu_, SIGNAL(highlighted(int)), SLOT(statusCallback(int)));

  connect(printerMenu_, SIGNAL(activated(int)), SLOT(commandCallback(int)));
  connect(printerMenu_, SIGNAL(highlighted(int)), SLOT(statusCallback(int)));

  connect(viewMenu_, SIGNAL(activated(int)), SLOT(commandCallback(int)));
  connect(viewMenu_, SIGNAL(highlighted(int)), SLOT(statusCallback(int)));
}

void KupsApp::initToolBar()
{

  ///////////////////////////////////////////////////////////////////
  // TOOLBAR
  toolBar()->insertButton(BarIcon("configure"), ID_FILE_OPTIONS, true, i18n("Options"));
  toolBar()->insertButton(BarIcon("fileprint"), ID_PRINTING_TEST, true, i18n("Print test page"));
  toolBar()->insertButton(BarIcon("kups_add"), ID_PRINTER_ADD, true, i18n("Add"));
  toolBar()->insertSeparator();
  toolBar()->insertButton(BarIcon("exit"), ID_FILE_QUIT, true, i18n("Quit"));
  toolBar()->insertSeparator();
  //toolBar()->insertButton(Icon("help.xpm", KIcon::Toolbar), ID_HELP_CONTENTS, SIGNAL(clicked()),kapp, SLOT(appHelpActivated()), true,i18n("Help"));

  ///////////////////////////////////////////////////////////////////
  // INSERT YOUR APPLICATION SPECIFIC TOOLBARS HERE WITH toolBar(n)


  ///////////////////////////////////////////////////////////////////
  // CONNECT THE TOOLBAR SLOTS WITH SIGNALS - add new created toolbars by their according number
  // connect for invoking the slot actions
  connect(toolBar(), SIGNAL(clicked(int)), SLOT(commandCallback(int)));
  // connect for the status help on holing icons pressed with the mouse button
  connect(toolBar(), SIGNAL(pressed(int)), SLOT(statusCallback(int)));

}
*/
void KupsApp::initActions()
{
	// File menu
	KStdAction::quit(this, SLOT(slotFileQuit()), actionCollection());

	// Printer menu
	new KAction(i18n("&Add printer/class..."), QString("wizard"), 0, this, SLOT(slotPrinterAdd()), actionCollection(), "printer_add");
	new KAction(i18n("&Test printer"), QString("fileprint"), 0, this, SLOT(slotPrintingTest()), actionCollection(), "printer_test");
	new KAction(i18n("Print a &file"), QString("postscript"), 0, this, SLOT(slotPrintingPSFile()), actionCollection(), "printer_ps_file");
	actionCollection()->action("printer_test")->setEnabled(false);

	// CUPS daemon configuration
	new KAction(i18n("&Configure CUPS"), QString("gear"), 0, this, SLOT(slotConfigureServer()), actionCollection(), "options_configure_server");
	new KAction(i18n("&Restart CUPS"), QString("exec_start"), 0, this, SLOT(slotRestartServer()), actionCollection(), "options_restart_server");

	// Window refresh
	new KAction(i18n("&Refresh"), QString("reload"), KStdAccel::reload(), this, SLOT(slotRefresh()), actionCollection(), "printer_refresh");

	// Settings menu
	KStdAction::showToolbar(this, SLOT(slotViewToolBar()), actionCollection());
	KStdAction::showStatusbar(this, SLOT(slotViewStatusBar()), actionCollection());
	KStdAction::configureToolbars(this, SLOT(slotConfigureToolbars()), actionCollection());
	KStdAction::preferences(this, SLOT(slotFileOptions()), actionCollection());

	i18n("Serve&r");
	i18n("&Printer");

	// create GUI
	createGUI();
}

void KupsApp::initStatusBar()
{
  ///////////////////////////////////////////////////////////////////
  // STATUSBAR
  // TODO: add your own items you need for displaying current application status.
  statusBar()->insertItem(i18n(IDS_STATUS_DEFAULT), ID_STATUS_MSG);
}

bool KupsApp::initView()
{ 
  ////////////////////////////////////////////////////////////////////
  // create the main widget here that is managed by KTMainWindow's view-region and
  // connect the widget to your document to display document contents.

  view_ = new KupsView(this, config_);
  setView(view_);

  KPrinterManager* prMgr = KPrinterManager::get();
  if (prMgr == 0)
  {
  	QString str;
  	str = "ERROR: ";
  	str += prMgr->getLastError();
  	str += "\nExiting now";
  	QMessageBox::critical(this,i18n("Printer administrator"),str.data(),QMessageBox::Ok|QMessageBox::Default,0);
  	return false;
  }

  if (!prMgr->refresh())
  {
  	QString str;
  	str = "ERROR: ";
  	str += prMgr->getLastError();
  }

	return true;
}

/*void KupsApp::enableCommand(int id_)
{
  ///////////////////////////////////////////////////////////////////
  // enable menu and toolbar functions by their ID's
//  menuBar()->setItemEnabled(id_, true);
//  toolBar()->setItemEnabled(id_, true);
}

void KupsApp::disableCommand(int id_)
{
  ///////////////////////////////////////////////////////////////////
  // disable menu and toolbar functions by their ID's
//  menuBar()->setItemEnabled(id_, false);
//  toolBar()->setItemEnabled(id_, false);
}
*/
void KupsApp::saveOptions()
{
  config_->setGroup("General Options");
  config_->writeEntry("Geometry", size());
/*  config_->writeEntry("Show Toolbar", toolBar()->isVisible());
  config_->writeEntry("Show Statusbar",statusBar()->isVisible());
*/
}


void KupsApp::readOptions()
{
  config_->setGroup("General Options");
/*
  // bar status settings
  bool bViewToolbar = config_->readBoolEntry("Show Toolbar", true);
  viewMenu_->setItemChecked(ID_VIEW_TOOLBAR, bViewToolbar);
  if(!bViewToolbar)
  {
     enableToolBar(KToolBar::Hide);
  }

  bool bViewStatusbar = config_->readBoolEntry("Show Statusbar", true);
  viewMenu_->setItemChecked(ID_VIEW_STATUSBAR, bViewStatusbar);
  if(!bViewStatusbar)
  {
    enableStatusBar(KStatusBar::Hide);
  }
*/
  QSize	defsize(620,470);
  QSize size=config_->readSizeEntry("Geometry",&defsize);
  if(!size.isEmpty())
  {
    resize(size);
  }
}

void KupsApp::saveProperties(KConfig *)
{
}


void KupsApp::readProperties(KConfig* )
{
}

bool KupsApp::queryClose()
{
	return true;
}

bool KupsApp::queryExit()
{
  saveOptions();
  return true;
}

/////////////////////////////////////////////////////////////////////
// SLOT IMPLEMENTATION
/////////////////////////////////////////////////////////////////////

void KupsApp::slotRefresh()
{
        view_->slotTimeout();
}

void KupsApp::slotFileOptions()
{
	view_->stopTimer();

	Kups_ConfigDialog dlg(this);
	dlg.initDialog();
	if (dlg.exec())
	{
		checkCUPSAccess();
		view_->slotTimeout();
	}
	else view_->startTimer();
}

void KupsApp::slotPrintingPSFile()
{
  slotStatusMsg(i18n("Printing a file..."));

  view_->stopTimer();
  view_->printPSFile();
  view_->startTimer();

  slotStatusMsg(i18n(IDS_STATUS_DEFAULT));
}

void KupsApp::slotPrintingTest()
{
	slotStatusMsg(i18n("Printing..."));
	view_->stopTimer();

/*  QCupsPrintDialog	dlg(this);
  if (dlg.exec())
  {
    view_->print( QString(dlg.printerName()) );
  }
*/

	view_->print();	// print a test page to current selected printer (no printer name given)

	view_->startTimer();
	slotStatusMsg(i18n(IDS_STATUS_DEFAULT));
}

void KupsApp::slotFileQuit()
{
	view_->stopTimer();

  slotStatusMsg(i18n("Exiting..."));
  saveOptions();
  // close the first window, the list makes the next one the first again.
  // This ensures that queryClose() is called on each window to ask for closing
  KMainWindow* w;
  if(memberList)
  {
    for(w=memberList->first(); w!=0; w=memberList->first())
    {
      // only close the window if the closeEvent is accepted. If the user presses Cancel on the saveModified() dialog,
      // the window and the application stay open.
      if(!w->close())
      {
				break;
			}
    }
  }
  //slotStatusMsg(i18n(IDS_STATUS_DEFAULT));
}

void KupsApp::slotConfigureToolbars()
{
  KEditToolbar	dlg(actionCollection());
  if (dlg.exec())
  {
    createGUI();
  }
}

void KupsApp::slotPrinterAdd()
{
	view_->stopTimer();

	Kap_AddPrinterWizard dlg(this);
	dlg.exec();

	view_->startTimer();
}

void KupsApp::slotConfigureServer()
{
	// TODO : server file name configurable in config file

	view_->stopTimer();

	Kups_Infos	*infos = Kups_Infos::get();
	CupsdDialog::configure( infos->getConfigFile(), this );

	view_->startTimer();
}

void KupsApp::slotRestartServer()
{
	view_->stopTimer();
	QString	msg;
	if (!CupsdDialog::restartServer(msg))
	{
		QMessageBox::critical(this, i18n("Error"), msg, QMessageBox::Ok|QMessageBox::Default, 0);
	}
	view_->startTimer();
}

void KupsApp::slotViewToolBar()
{
  slotStatusMsg(i18n("Toggle the toolbar..."));
  ///////////////////////////////////////////////////////////////////
  // turn Toolbar on or off
/*  if( viewMenu_->isItemChecked(ID_VIEW_TOOLBAR))
  {
    viewMenu_->setItemChecked(ID_VIEW_TOOLBAR, false);
    enableToolBar(KToolBar::Hide);
  }
  else
  {
    viewMenu_->setItemChecked(ID_VIEW_TOOLBAR, true);
    enableToolBar(KToolBar::Show);
  }
*/
  if (toolBar()->isVisible())
    toolBar()->hide();
  else
    toolBar()->show();
  slotStatusMsg(i18n(IDS_STATUS_DEFAULT));
}

void KupsApp::slotViewStatusBar()
{
  slotStatusMsg(i18n("Toggle the statusbar..."));
  ///////////////////////////////////////////////////////////////////
  //turn Statusbar on or off
/*  if( viewMenu_->isItemChecked(ID_VIEW_STATUSBAR))
  {
    viewMenu_->setItemChecked(ID_VIEW_STATUSBAR, false);
    enableStatusBar(KStatusBar::Hide);
  }
  else
  {
    viewMenu_->setItemChecked(ID_VIEW_STATUSBAR, true);
    enableStatusBar(KStatusBar::Show);
  }
*/
  if (statusBar()->isVisible())
    statusBar()->hide();
  else
    statusBar()->show();
  slotStatusMsg(i18n(IDS_STATUS_DEFAULT));
}


void KupsApp::slotStatusMsg(const QString &text)
{
  ///////////////////////////////////////////////////////////////////
  // change status message permanently
  statusBar()->clear();
  statusBar()->changeItem(text, ID_STATUS_MSG);
}


void KupsApp::slotStatusHelpMsg(const QString &text)
{
  ///////////////////////////////////////////////////////////////////
  // change status message of whole statusbar temporary (text, msec)
  statusBar()->message(text, 2000);
}



/*void KupsApp::commandCallback(int id_)
{
  switch (id_)
  {
    case ID_FILE_OPTIONS:
         slotFileOptions();
         break;
    case ID_FILE_SERVER:
         slotConfigureServer();
         break;
    case ID_FILE_QUIT:
         slotFileQuit();
         break;

    case ID_PRINTING_TEST:
         slotPrintingTest();
         break;
    case ID_PRINTING_PS_FILE:
         slotPrintingPSFile();
         break;

    case ID_PRINTER_ADD:
         slotPrinterAdd();
         break;

    case ID_VIEW_TOOLBAR:
         slotViewToolBar();
         break;
    case ID_VIEW_STATUSBAR:
         slotViewStatusBar();
         break;

    default:
         break;
  }
}*/

void KupsApp::statusCallback(int id_)
{
  switch (id_)
  {
    case ID_FILE_OPTIONS:
         slotStatusHelpMsg(i18n("Opens the options dialog"));
         break;
    case ID_FILE_SERVER:
         slotStatusHelpMsg(i18n("Opens the CUPS daemon configuration tool"));
         break;
    case ID_FILE_QUIT:
         slotStatusHelpMsg(i18n("Quits the application"));
         break;

    case ID_PRINTING_TEST:
         slotStatusHelpMsg(i18n("Prints a test page on the selected printer"));
         break;
    case ID_PRINTING_PS_FILE:
         slotStatusHelpMsg(i18n("Prints a PS file on the selected printer"));
         break;

    case ID_PRINTER_ADD:
         slotStatusHelpMsg(i18n("Adds a new printer") );
         break;

    case ID_VIEW_TOOLBAR:
         slotStatusHelpMsg(i18n("Enables/disables the toolbar"));
         break;
    case ID_VIEW_STATUSBAR:
         slotStatusHelpMsg(i18n("Enables/disables the statusbar"));
         break;

    default:
         break;
  }
}

void KupsApp::checkCUPSAccess()
{
	// first check for configuration file access
	QFileInfo	fi(Kups_Infos::get()->getConfigFile());
	actionCollection()->action("options_configure_server")->setEnabled((getuid() == 0 || fi.isWritable()));

	// then check for server process access
	actionCollection()->action("options_restart_server")->setEnabled((getuid() == 0 || getuid() == CupsdDialog::serverOwner()));
}
