/***************************************************************************
                          kups_infos.cpp  -  description
                             -------------------
    begin                : Sun Nov 28 1999
    copyright            : (C) 1999 by jec
    email                : cuendet@linkvest.ch
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


#include "kups_infos.h"
#include <qtcups/cupshelper.h>

Kups_Infos* Kups_Infos::infos_ = 0;

Kups_Infos::Kups_Infos()
:port_(-1),
testPage_("/devel/kups/kups/test_cups.ps"),
refreshTime_(2000)
{
	infos_ = this;
        CupsHelper::get();	// just to create the instance.
}
Kups_Infos::~Kups_Infos()
{
}
	
QString Kups_Infos::getServerPortIppUri()
{
	QString str;
	str.sprintf("ipp://%s:%d", server_.data(), port_);
	return str;
}

const QString& Kups_Infos::getServer()
{
	return CupsHelper::get()->host();
//	return server_;
}
void Kups_Infos::setServer(const QString& server)
{
	server_ = server;
	CupsHelper::get()->setHostInfo(server_.data(),port_);
}
	
int Kups_Infos::getPort()
{
	return CupsHelper::get()->port();
//	return port_;
}
void Kups_Infos::setPort(int port)
{
	port_ = port;
	CupsHelper::get()->setHostInfo(server_.data(),port_);
}

const QString& Kups_Infos::getUser()
{
	return CupsHelper::get()->login();
//	return user_;
}
void Kups_Infos::setUser(const QString& user)
{
	user_ = user;
	CupsHelper::get()->setLoginInfo(user_.data(),password_.data());
}
	
const QString& Kups_Infos::getPassword()
{
	return CupsHelper::get()->password();
//	return password_;
}
void Kups_Infos::setPassword(const QString& pwd)
{
	password_ = pwd;
	CupsHelper::get()->setLoginInfo(user_.data(),password_.data());
}
	
const QString& Kups_Infos::getConfigFile()
{
	return config_;
}
void Kups_Infos::setConfigFile(const QString& conf)
{
	config_ = conf;
}

const QString& Kups_Infos::getTestPage()
{
	return testPage_;
}
void Kups_Infos::setTestPage(const QString& test)
{
	testPage_ = test;
}

int Kups_Infos::getRefreshTime()
{
	return refreshTime_;
}
void Kups_Infos::setRefreshTime(int t)
{
	refreshTime_ = t;
}

bool Kups_Infos::isTimerEnabled()
{
	return usetimer_;
}
void Kups_Infos::setTimerEnabled(bool on)
{
	usetimer_ = on;
}

bool Kups_Infos::isStandardCUPS()
{
	return standardcups_;
}
void Kups_Infos::setStandardCUPS(bool on)
{
	standardcups_ = on;
}

const QString& Kups_Infos::getCUPSRoot()
{
	return cupsroot_;
}
void Kups_Infos::setCUPSRoot(const QString& conf)
{
	cupsroot_ = conf;
}

const QString& Kups_Infos::getDriversDir()
{
	return drivers_;
}
void Kups_Infos::setDriversDir(const QString& conf)
{
	drivers_ = conf;
}
