/***************************************************************************
                          kups_jobitem.cpp  -  description
                             -------------------
    begin                : Mon Dec 13 1999
    copyright            : (C) 1999 by jec
    email                : cuendet@linkvest.ch
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <klocale.h>

#include "kups_jobitem.h"

#include "kjob.h"
#include "kprinter.h"



Kups_JobItem::Kups_JobItem(QListView* parent)
:Kups_ListItem(parent),
job_(0)
{
}
Kups_JobItem::Kups_JobItem(QListViewItem* parent)
:Kups_ListItem(parent),
job_(0)
{
}
Kups_JobItem::~Kups_JobItem()
{
}
QString Kups_JobItem::text ( int column ) const
{
	static QString str;
	str = "";
	switch(column)
	{
	case 1: // ID
		str.setNum(job_->getID());
		return str.data();
	case 0: // name
		return (job_->getName().isEmpty() ? i18n("<Unnamed>") : job_->getName());
	case 2:	// job state
		switch (job_->getState())
		{
		   case IPP_JOB_PENDING: return i18n("Pending");
		   case IPP_JOB_HELD: return i18n("Held");
		   case IPP_JOB_PROCESSING: return i18n("Processing...");
		   case IPP_JOB_STOPPED: return i18n("Print stopped");
		   default: return i18n("Unknown");
		}
	case 3: // printer
		return job_->getPrinter()->getName();
	case 4: // owner
		return job_->getUserName();
	case 5: // size
		str.setNum(job_->getSize());
		return str.data();
	default:
		break;
	};
	str = "<Unknown>";
	return str;
}
