/***************************************************************************
                          kups_printeritem.h  -  description
                             -------------------
    begin                : Sun Nov 14 1999
    copyright            : (C) 1999 by jec
    email                : cuendet@linkvest.ch
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef KUPS_PRINTERITEM_H
#define KUPS_PRINTERITEM_H


#include <qlistview.h>


/**
  *@author jec
*/

class KPrinter;

class Kups_ListItem : public QListViewItem
{
public:
	Kups_ListItem(QListView* parent, const char *name=0);
	Kups_ListItem(QListViewItem* parent, const char *name=0);
	~Kups_ListItem();
	
	void setIsDiscarded(bool val) { isDiscarded_ = val; };
	bool isDiscarded() { return isDiscarded_; };
	
private:
	bool isDiscarded_;
};

class Kups_PrinterItem : public Kups_ListItem
{
public:
	enum PrinterType { NONE, ALL, ALL_PRINTERS, ALL_CLASSES, PRINTER, CLASS };
	
	Kups_PrinterItem(QListView* parent, bool allColumns, const char *name=0);
	Kups_PrinterItem(QListViewItem* parent, bool allColumns, const char *name=0);
	~Kups_PrinterItem();

	Kups_PrinterItem* addChild(KPrinter* printer, PrinterType type = PRINTER);
	void deleteAllChildrenDiscarded();   Kups_PrinterItem* getChildWithPrinter(KPrinter* printer);
	void setAllChildrenDiscarded(bool disc);
	
	void setPrinter(KPrinter* printer);
	KPrinter* getPrinter();

	QString text ( int column ) const;
	
	PrinterType getPrinterType() { return printerType_; };
	void setPrinterType(PrinterType type) { printerType_ = type; };

	virtual void paintCell(QPainter *p, const QColorGroup& cg, int column, int width, int alignment);
	
private:
	KPrinter* printer_;
	bool allColumns_;
	
	PrinterType printerType_;
};

#endif

