/***************************************************************************
                          kups_printerpage.h  -  description
                             -------------------
    begin                : Mon Nov 22 1999
    copyright            : (C) 1999 by jec
    email                : cuendet@linkvest.ch
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef KUPS_PRINTERVIEW_H
#define KUPS_PRINTERVIEW_H

// QT includes
#include <qwidget.h>
#include <qlistview.h>


// KUPS includes



/**
  *@author jec
  */


class Kups_PrinterItem;
class KupsView;
class Kups_PrinterObserver;
class KPrinter;

class Kups_PrinterView : public QListView
{
   Q_OBJECT
public:
	Kups_PrinterView(QWidget* parent, const char *name, KupsView* view, bool allColumns);
	~Kups_PrinterView();
	
	bool initWidgets();
	bool initPrinterWidgets();
	bool initClassWidgets();
	
	KPrinter* getSelectedPrinter();
	
	KupsView* getView() { return view_; };

protected slots:
	void slotRightOnItem(QListViewItem* item, const QPoint& point, int i);
	
protected:
	void updatePrintersForClass(Kups_PrinterItem* parent);
	bool createWidgets();
	virtual void resizeEvent(QResizeEvent * e );
	
private:
	Kups_PrinterObserver* observer_;
	
	bool allColumns_;
	KupsView* view_;
	
	Kups_PrinterItem* all_;
	Kups_PrinterItem* allPrinters_;
	Kups_PrinterItem* allClasses_;
	
};

#endif





















