/***************************************************************************
                          kupsview.h  -  description
                             -------------------
    begin                : Mon Nov  8 19:59:21 CET 1999
    copyright            : (C) 1999 by jec
    email                : cuendet@linkvest.ch
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef KUPSVIEW_H
#define KUPSVIEW_H

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

// include files for Qt
#include <qwidget.h>
#include <qstrlist.h>

// include files for KDE
#include <qsplitter.h>
//#include <qtabwidget.h>

// include files for KUPS
#include "kups_infos.h"



class QTimer;
class QTabWidget;
class QListViewItem;

class KConfig;

class Kups_JobsView;
class Kups_PrinterView;
class Kups_PrinterInfo;
class Kups_PrinterPropView;


/** The KupsView class provides the view widget for the KupsApp instance.
 * The View instance inherits QWidget as a base class and represents the view object of a KTMainWindow. As KupsView is part of the
 * docuement-view model, it needs a reference to the document object connected with it by the KupsApp class to manipulate and display
 * the document structure provided by the KupsDoc class.
 *
 * @author Source Framework Automatically Generated by KDevelop, (c) The KDevelop Team.
 * @version KDevelop version 0.4 code generation
 */




//class KupsView : public QWidget
class KupsView : public QSplitter
{
  Q_OBJECT
public:
	static bool authMethod();

  /** Constructor for the main view */
	KupsView(QWidget *parent, KConfig* config, const char* name = 0);
  /** Destructor for the main view */
  ~KupsView();

  static KupsView* get();

	bool isValid() { return isValid_; };
	
	/** contains the implementation for printing functionality */
	void print(const QString& printerName = QString::null);
	void printPSFile();

	void readOptions(KConfig* config);
	void saveOptions(KConfig* config);

	void stopTimer();
	void startTimer();

protected:
	bool createWidgets();
	virtual bool initWidgets();

public slots:
	void slotTimeout();

protected slots:
	void slotPrinterSelected(QListViewItem*);

private:
	bool isValid_;

        QTabWidget* tabs_;
        Kups_JobsView* jobsView_;
	Kups_PrinterView* printerView_;
	Kups_PrinterInfo* printerInfo_;
	Kups_PrinterPropView* propView_;

	QTimer* timer_;

	KConfig* config_;

	Kups_Infos infos_;

	static KupsView* unique_;
};

#endif // KUPSVIEW_H











