#ifndef CUPSDSERVERSECURITYPAGE_H
#define CUPSDSERVERSECURITYPAGE_H

#include "cupsdpage.h"

#include <qlist.h>

class QLineEdit;
class QListView;
class CupsdOption;
class CupsLocation;

class CupsdServerSecurityPage : public CupsdPage
{
	Q_OBJECT;
public:
	CupsdServerSecurityPage(QWidget *parent = 0, const char *name = 0);
	~CupsdServerSecurityPage();

	bool loadConfig(CupsdConf *conf, QString& msg);
	bool saveConfig(CupsdConf *conf, QString& msg);
	void setDefaults();
        void setInfos(CupsdConf*);

protected:
	void updateLocations();

protected slots:
	void addClicked();
	void modifyClicked();
	void removeClicked();

private:
	QLineEdit	*systemgroup_;
	QListView	*locations_;

	CupsdOption	*opt_[1];
	QList<CupsLocation>	loclist_;
};

#endif
