#ifndef MYDIALOGBASE_H
#define MYDIALOGBASE_H

#include <qdialog.h>

class QListView;
class QListViewItem;
class QWidgetStack;
class QLabel;
class MyPage;

class MyDialogBase : public QDialog
{
        Q_OBJECT
public:
        MyDialogBase(QWidget *parent = 0, const char *name = 0);
        ~MyDialogBase();

        void addPage(const QStringList& path, const QString& header, const QPixmap& icon, QWidget *w);

protected slots:
        virtual void slotOk();
        virtual void slotCancel();
        virtual void slotApply();
        void slotItemSelected(QListViewItem*);
        virtual void slotHelp();

private:
        QListViewItem* findParent(const QStringList& path);

private:
        QListView       *tree_;
        QWidgetStack    *stack_;
        QLabel          *title_;
};

#endif
